#!/bin/sh 

#-----------------------------------
# Script to import type definitions
#-----------------------------------

VCSHOME="${VCS_HOME:-/opt/VRTSvcs}"
PATH=${VCSHOME}/bin:$PATH
export PATH

type=`hatype -list`
if [ $? -eq 0 ]; then
	if [ `echo $type | grep -c "OraDG"` -ge 1 ]; then
		exit 0;
	else
		echo "Adding Type Definition"
	fi
else
	echo "Unable to add the OraDG type. VCS Engine is not running. Start VCS Engine and execute the script /etc/VRTSvcs/conf/sample_oradg/addOraDGType.sh"
	exit 0;
fi

ro=`haclus -value ReadOnly`
if [ $? -eq 0 ]; then
        if [ "$ro" -eq 1 ]; then
                ${VCSHOME}/bin/haconf -makerw
        fi
else
        echo "Unable to add the OraDG type. VCS Engine is not running. Start VCS Engine and execute the script /etc/VRTSvcs/conf/sample_oradg/addOraDGType.sh"
        exit 0;
fi


set -e
set -u

agent_name="OraDG"
conf_dir="/etc/VRTSvcs/conf"
tmp_dir="${conf_dir}/temp"
cf_file=${agent_name}Types.cf


#--------------------------------
# For Solaris : Get HAD Version
#--------------------------------
#for Had version greater or equal to 5.1 use OraDGTypes.cf
#for Had version below 5.1 use OraDGTypes50.cf

os_name=`/bin/uname -s`
if [ "${os_name}" = "SunOS" ]; then
        #------------------
        # Define commands..
        #------------------
        grep_cmd="/bin/grep"
        awk_cmd="/bin/awk"
	sed_cmd="/bin/sed"

        if [ ! -f "/bin/grep" ]; then
          grep_cmd=grep
        fi
        if [ ! -f "/bin/awk" ]; then
          sed_cmd=awk
        fi
	if [ ! -f "/bin/sed" ]; then
          sed_cmd=sed
        fi

        had_ver=`/opt/VRTSvcs/bin/had -version | $grep_cmd "Join Version" | $awk_cmd {'print $NF'}`
        had_shortver=`echo $had_ver| \
        $sed_cmd -e 's/[\.]//g
        s/^\([0-9]\{4\}\).*/\1/'`

        cf_file=${agent_name}Types50.cf
        if [ $had_shortver -ge 5100 ]; then
                cf_file=${agent_name}Types.cf
        fi
fi

cur_dir=`pwd`
cd ${conf_dir}
mkdir -p ${tmp_dir}
cp ${cf_file} ${tmp_dir}/${cf_file}
echo "include \"${cf_file}\"" > ${tmp_dir}/main.cf
cd ${tmp_dir}

hacf -verify .
sh main.cmd

if [ $ro -eq 1 ];
then
        ${VCSHOME}/bin/haconf -dump -makero
else
        ${VCSHOME}/bin/haconf -dump
fi

cd ${cur_dir}
rm ${tmp_dir}/${cf_file}
rm ${tmp_dir}/main.cf
rm ${tmp_dir}/main.cmd
rmdir ${tmp_dir}

echo "${agent_name} Agent Type successfully imported."

